## ros-rviz 1.14.1+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(rviz)

if (POLICY CMP0042)
  cmake_policy(SET CMP0042 NEW)
endif()
if (POLICY CMP0054)
  cmake_policy(SET CMP0054 NEW)
endif()

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# Define global caktin_lint suppressions
#catkin_lint: ignore uninstalled_script missing_install_target

find_package(Boost REQUIRED
  COMPONENTS
  filesystem
  program_options
  system
  thread
)

find_package(urdfdom_headers REQUIRED)

find_package(ASSIMP REQUIRED)
include_directories(${ASSIMP_INCLUDE_DIRS})

# OGRE doesn't come with correctly installed cmake files.
# We need both, OGRE and OGRE-Overlay. Look for both simulatenously and use prefix X_
find_package(PkgConfig REQUIRED)
pkg_check_modules(X OGRE OGRE-Overlay)

# TODO: adapt version for Noetic release
# Disable deprecation warnings for OGRE >= 1.10
if(NOT X_OGRE_VERSION VERSION_LESS "1.10.0" AND NOT MSVC)
  add_compile_options(-Wno-deprecated-declarations)
endif()

# find absolute path of ogre libraries.
# This is stored in the cache to save time on cmake re-run.
# Using absolute paths is necessary if pkg-config finds Ogre in a different
# location than the default.  This can happen when Ogre is built from source,
# or when 2 versions of Ogre are installed.  Using absolute paths ensures that
# components that link against Ogre (rviz and any packages depending on rviz)
# all find the same Ogre shared library.
if(NOT DEFINED OGRE_LIBRARIES)
  set(_OGRE_LIBRARIES)
  foreach(_lib ${X_LIBRARIES})
    set(_lib_tag "OGRE_RVIZ_${_lib}")

    find_library(${_lib_tag}
            NAMES ${_lib}
            HINTS ${X_LIBRARY_DIRS}
            PATHS ${X_LIBRARY_DIRS}
    )

    list(APPEND _OGRE_LIBRARIES ${${_lib_tag}})
  endforeach(_lib)

  set(OGRE_LIBRARIES ${_OGRE_LIBRARIES} CACHE STRING "Absolute paths to OGRE libs")
endif(NOT DEFINED OGRE_LIBRARIES)
message(STATUS "OGRE_LIBRARIES=${OGRE_LIBRARIES}")

# Define OGRE_INCLUDE_DIRS as find_package would do
set(OGRE_INCLUDE_DIRS ${X_INCLUDE_DIRS})
message(STATUS "OGRE_INCLUDE_DIRS=${OGRE_INCLUDE_DIRS}")

## Find OGRE Plugin path (not necessarily platform-independent, I guess)
if(NOT DEFINED OGRE_PLUGIN_PATH)
  execute_process(COMMAND
    ${PKG_CONFIG_EXECUTABLE} --variable=plugindir OGRE
    OUTPUT_VARIABLE OGRE_PLUGIN_PATH
    OUTPUT_STRIP_TRAILING_WHITESPACE
    )
endif(NOT DEFINED OGRE_PLUGIN_PATH)
message(STATUS "OGRE_PLUGIN_PATH=${OGRE_PLUGIN_PATH}")

if(APPLE)
  FIND_LIBRARY(Cocoa_LIBRARIES Cocoa)
  set(rviz_ADDITIONAL_LIBRARIES ${Cocoa_LIBRARIES})

  # This definition prevents an Apple header from defining a macro called "check", which if
  # present, collides with another function in the rviz code. See:
  # https://opensource.apple.com/source/CarbonHeaders/CarbonHeaders-18.1/AssertMacros.h
  add_definitions(-D__ASSERT_MACROS_DEFINE_VERSIONS_WITHOUT_UNDERSCORES=0)
endif()

# Prefer newer vender-specific OpenGL library
if (POLICY CMP0072)
  cmake_policy(SET CMP0072 NEW)
endif()
find_package(OpenGL REQUIRED)

set(CMAKE_AUTOMOC ON)

find_package(Qt5 REQUIRED COMPONENTS Core Widgets OpenGL)
set(QT_LIBRARIES Qt5::Widgets)
set(QTVERSION ${Qt5Widgets_VERSION})
add_definitions(-DQT_NO_KEYWORDS)

find_package(catkin REQUIRED
  COMPONENTS
  cmake_modules
  geometry_msgs
  image_transport
  interactive_markers
  laser_geometry
  map_msgs
  message_filters
  message_generation
  nav_msgs
  pluginlib
  python_qt_binding
  resource_retriever
  rosbag
  rosconsole
  roscpp
  roslib
  rospy
  sensor_msgs
  std_msgs
  std_srvs
  tf2_ros
  tf2_geometry_msgs
  urdf
  visualization_msgs
)

find_package(PythonLibs "${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}" REQUIRED)

find_package(Eigen3 QUIET)
if(NOT EIGEN3_FOUND)
  #catkin_lint: ignore_once deprecated_cmake_module
  find_package(Eigen REQUIRED)
  set(EIGEN3_INCLUDE_DIRS ${EIGEN_INCLUDE_DIRS})
  set(EIGEN3_LIBRARIES ${EIGEN_LIBRARIES})  # Not strictly necessary as Eigen is head only
  # Possibly map additional variables to the EIGEN3_ prefix.
else()
  set(EIGEN3_INCLUDE_DIRS ${EIGEN3_INCLUDE_DIR})
endif()

find_package(TinyXML2 REQUIRED)

catkin_python_setup()

# Set the Qt version for use in the extras file.
set(rviz_QT_VERSION ${QTVERSION})

# This variable controls the target name of the default plugin library.
# It is used in the extras file (processed in caktin_package(...)) and the
# cmake code for the default plugin.
# There is a matching instance of this in the plugin_description.xml.
set(rviz_DEFAULT_PLUGIN_LIBRARY_TARGET_NAME rviz_default_plugin)

add_service_files(
  FILES
  SendFilePath.srv
)

generate_messages(
  DEPENDENCIES
  std_msgs
)

set(EXPORT_HEADER_DIR "${CATKIN_DEVEL_PREFIX}/include")
file(MAKE_DIRECTORY "${EXPORT_HEADER_DIR}")

#catkin_lint: ignore_once external_include_path
catkin_package(
  CFG_EXTRAS
    rviz-extras.cmake
  INCLUDE_DIRS
    src
    ${EXPORT_HEADER_DIR}
    ${EIGEN3_INCLUDE_DIRS}
    ${OGRE_INCLUDE_DIRS}
    ${OPENGL_INCLUDE_DIR}
  LIBRARIES
    rviz
    ${OGRE_LIBRARIES}
    ${rviz_ADDITIONAL_LIBRARIES}
    ${OPENGL_LIBRARIES}
  CATKIN_DEPENDS
    geometry_msgs
    image_transport
    interactive_markers
    laser_geometry
    map_msgs
    message_filters
    message_runtime
    nav_msgs
    pluginlib
    resource_retriever
    roscpp
    roslib
    sensor_msgs
    std_msgs
    std_srvs
    tf2_ros
    urdf
    visualization_msgs
)

if(CMAKE_VERSION VERSION_GREATER_EQUAL "3.14.0")
    set(SYSTEM "SYSTEM")
endif()

include_directories(${SYSTEM}
  ${EIGEN3_INCLUDE_DIRS}
  ${OGRE_INCLUDE_DIRS}
  ${OPENGL_INCLUDE_DIR}
  ${PYTHON_INCLUDE_PATH}
  ${TinyXML2_INCLUDE_DIRS}
  ${urdfdom_headers_INCLUDE_DIRS}
)
#catkin_lint: ignore_once external_directory
include_directories(src ${EXPORT_HEADER_DIR})
include_directories(${SYSTEM} ${catkin_INCLUDE_DIRS})

#### If gtk ends up being the best way to get the correct window
#### position under X11, this is how to compile it in.
#
# find_package(GTK2)
# include_directories(${GTK2_INCLUDE_DIRS})
# include_directories(/usr/include/gdk-pixbuf-2.0)

add_subdirectory(src)

install(DIRECTORY ogre_media
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)
install(DIRECTORY icons
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)
install(DIRECTORY images
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)
install(FILES default.rviz
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)
install(FILES plugin_description.xml
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)
install(FILES help/help.html
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/help
)
#catkin_lint: ignore uninstalled_target

=== src/rviz/default_plugin/CMakeLists.txt ===
set(SOURCE_FILES
  axes_display.cpp
  camera_display.cpp
  covariance_visual.cpp
  covariance_property.cpp
  depth_cloud_display.cpp
  depth_cloud_mld.cpp
  effort_display.cpp
  effort_visual.cpp
  fluid_pressure_display.cpp
  grid_cells_display.cpp
  grid_display.cpp
  illuminance_display.cpp
  image_display.cpp
  interactive_marker_display.cpp
  interactive_markers/integer_action.cpp
  interactive_markers/interactive_marker_control.cpp
  interactive_markers/interactive_marker.cpp
  laser_scan_display.cpp
  map_display.cpp
  marker_array_display.cpp
  marker_display.cpp
  marker_utils.cpp
  markers/arrow_marker.cpp
  markers/line_list_marker.cpp
  markers/line_strip_marker.cpp
  markers/marker_base.cpp
  markers/marker_selection_handler.cpp
  markers/mesh_resource_marker.cpp
  markers/points_marker.cpp
  markers/shape_marker.cpp
  markers/text_view_facing_marker.cpp
  markers/triangle_list_marker.cpp
  odometry_display.cpp
  path_display.cpp
  point_display.cpp
  point_visual.cpp
  point_cloud2_display.cpp
  point_cloud_common.cpp
  point_cloud_display.cpp
  point_cloud_transformer.h
  point_cloud_transformers.cpp
  polygon_display.cpp
  pose_array_display.cpp
  pose_display.cpp
  pose_with_covariance_display.cpp
  range_display.cpp
  relative_humidity_display.cpp
  robot_model_display.cpp
  temperature_display.cpp
  tf_display.cpp
  tools/focus_tool.cpp
  tools/measure_tool.cpp
  tools/move_tool.cpp
  tools/point_tool.cpp
  tools/pose_tool.cpp
  tools/goal_tool.cpp
  tools/initial_pose_tool.cpp
  tools/selection_tool.cpp
  tools/interaction_tool.cpp
  view_controllers/orbit_view_controller.cpp
  view_controllers/xy_orbit_view_controller.cpp
  view_controllers/third_person_follower_view_controller.cpp
  view_controllers/fixed_orientation_ortho_view_controller.cpp
  view_controllers/fps_view_controller.cpp
  view_controllers/frame_view_controller.cpp
  wrench_display.cpp
  wrench_visual.cpp
)

add_library(${rviz_DEFAULT_PLUGIN_LIBRARY_TARGET_NAME} ${SOURCE_FILES})
include(GenerateExportHeader)
set(EXPORT_FILE_NAME ${EXPORT_HEADER_DIR}/rviz/default_plugin/${rviz_DEFAULT_PLUGIN_LIBRARY_TARGET_NAME}_export.h)
generate_export_header(${rviz_DEFAULT_PLUGIN_LIBRARY_TARGET_NAME} EXPORT_FILE_NAME ${EXPORT_FILE_NAME})
if(NOT WIN32)
  set_target_properties(${rviz_DEFAULT_PLUGIN_LIBRARY_TARGET_NAME}
    PROPERTIES COMPILE_FLAGS "-std=c++11")
endif()
target_link_libraries(${rviz_DEFAULT_PLUGIN_LIBRARY_TARGET_NAME}
  ${PROJECT_NAME}
  ${Boost_LIBRARIES}
  ${catkin_LIBRARIES}
  ${OGRE_LIBRARIES}
  ${QT_LIBRARIES}
)

#catkin_lint: ignore_once external_file
install(FILES
  ${EXPORT_FILE_NAME}
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}/default_plugin/)

install(TARGETS ${rviz_DEFAULT_PLUGIN_LIBRARY_TARGET_NAME}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_GLOBAL_BIN_DESTINATION})

# Generate to the devel space so the extras file can include it from the devel space.
file(GENERATE
  OUTPUT "${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/cmake/default_plugin_location.cmake"
  CONTENT "set(rviz_DEFAULT_PLUGIN_FILE_NAME $<TARGET_LINKER_FILE_NAME:${rviz_DEFAULT_PLUGIN_LIBRARY_TARGET_NAME}>)"
)
#catkin_lint: ignore_once external_file
# Install from the devel space to the install space.
install(FILES "${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/cmake/default_plugin_location.cmake"
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/cmake
)

=== debian/changelog ===
ros-rviz (1.14.1+dfsg-1) unstable; urgency=medium

  * New upstream version 1.14.1+dfsg
  * Simplify dependencies

 -- Jochen Sprickerhof <jspricke@debian.org>  Tue, 07 Jul 2020 07:21:23 +0200

ros-rviz (1.14.0+dfsg-1) experimental; urgency=medium

  * New upstream version 1.14.0+dfsg
  * Remove Thomas from Uploaders, thanks for working on this
  * update copyright
  * rebase patches
  * bump debhelper versions
  * bump Soname due to ABI change

 -- Jochen Sprickerhof <jspricke@debian.org>  Sun, 21 Jun 2020 14:00:39 +0200

ros-rviz (1.13.7+dfsg-2) unstable; urgency=medium

  * Support multiple Python versions
  * bump policy version (no changes)

 -- Jochen Sprickerhof <jspricke@debian.org>  Mon, 06 Apr 2020 18:59:45 +0200

=== debian/control ===
Source: ros-rviz
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Jochen Sprickerhof <jspricke@debian.org>,
           Leopold Palomo-Avellaneda <leo@alaxarxa.net>
Build-Depends: debhelper-compat (= 13), catkin, libboost-filesystem-dev, libboost-program-options-dev, libboost-system-dev, libboost-thread-dev, libassimp-dev, libgl1-mesa-dev | libgl-dev, libqt5opengl5-dev, libimage-transport-dev, libinteractive-markers-dev (>= 1.12.0) , liblaser-geometry-dev, libmap-msgs-dev, libmessage-filters-dev, libnav-msgs-dev, pluginlib-dev, python3-python-qt-binding, libresource-retriever-dev, librosbag-dev, librosconsole-dev, libroscpp-dev, libroslib-dev, python3-rospy, libsensor-msgs-dev, libstd-msgs-dev, libstd-srvs-dev, libtf-dev, liburdf-dev, libvisualization-msgs-dev, libeigen3-dev, libogre-1.9-dev, librostest-dev, libyaml-cpp-dev, liburdfdom-dev, python3-all-dev, dh-sequence-python3, python3-sip-dev, libx11-dev, chrpath, libstd-msgs-dev, ros-std-msgs,
Standards-Version: 4.5.0
Section: libs
Rules-Requires-Root: no
Homepage: https://wiki.ros.org/rviz
Vcs-Git: https://salsa.debian.org/science-team/ros-rviz.git
Vcs-Browser: https://salsa.debian.org/science-team/ros-rviz

Package: librviz-dev
Section: libdevel
Architecture: any
Depends: librviz5d (= ${binary:Version}), ${misc:Depends}, libimage-transport-dev, libinteractive-markers-dev (>= 1.12.0) , liblaser-geometry-dev, libmap-msgs-dev, libmessage-filters-dev, libnav-msgs-dev, pluginlib-dev, python3-python-qt-binding, libresource-retriever-dev, librosbag-dev, librosconsole-dev, libroscpp-dev, libroslib-dev, python3-rospy, libsensor-msgs-dev, libstd-msgs-dev, libstd-srvs-dev, libtf-dev, liburdf-dev, libvisualization-msgs-dev, libogre-1.9-dev
Description: Development files for the Robot OS 3D visualization tool
 This package is part of Robot OS (ROS) RViz package. RViz is a tool to
 visualize ROS messages and the state of the robot.
 .
 This package contains the development files for the rviz library.

Package: librviz5d
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Library for the Robot OS 3D visualization tool
 This package is part of Robot OS (ROS) RViz package. RViz is a tool to
 visualize ROS messages and the state of the robot.
 .
 This package contains the rviz library.

Package: rviz
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, fonts-liberation, libqt5svg5
Description: 3D visualization tool for Robot OS
 This package is part of Robot OS (ROS) RViz package. RViz is a tool to
 visualize ROS messages and the state of the robot.
 .
 This package contains the rviz program.

Package: python3-rviz
Section: python
Architecture: any
Depends: ${python3:Depends}, ${sip3:Depends}, ${shlibs:Depends}, ${misc:Depends}, python3-python-qt-binding
Description: Python 3 bindings for the 3D visualization tool for Robot OS
 This package is part of Robot OS (ROS) RViz package. RViz is a tool to
 visualize ROS messages and the state of the robot.
 .
 This package contains the Python 3 interface to the rviz library.

## ros-rviz 1.14.4+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
   cmake_policy(SET CMP0054 NEW)
 endif()
 
-set(CMAKE_CXX_STANDARD 11)
+set(CMAKE_CXX_STANDARD 14)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_CXX_EXTENSIONS OFF)
 
@@ -25,58 +25,66 @@
 
 find_package(urdfdom_headers REQUIRED)
 
+set(CMAKE_POLICY_DEFAULT_CMP0012 NEW)  # required due to a bug in assimp 5.0
 find_package(ASSIMP REQUIRED)
-include_directories(${ASSIMP_INCLUDE_DIRS})
-
-# OGRE doesn't come with correctly installed cmake files.
-# We need both, OGRE and OGRE-Overlay. Look for both simulatenously and use prefix X_
-find_package(PkgConfig REQUIRED)
-pkg_check_modules(X OGRE OGRE-Overlay)
-
-# TODO: adapt version for Noetic release
+if(NOT DEFINED ASSIMP_LIBRARIES AND TARGET assimp::assimp)
+  # ASSIMP >= 5.0 no longer defines ASSIMP_LIBRARIES
+  set(ASSIMP_LIBRARIES assimp::assimp)
+endif()
+
+find_package(OGRE QUIET COMPONENTS Overlay)
+if(NOT OGRE_FOUND)
+  # OGRE doesn't come with correctly installed cmake files on Linux. Use pkg-config instead.
+  # We need both, OGRE and OGRE-Overlay. Look for both simulatenously and use prefix X_
+  find_package(PkgConfig REQUIRED)
+  pkg_check_modules(X REQUIRED OGRE OGRE-Overlay)
+
+  # Set OGRE_* variables as cmake-based find_package would do
+  set(OGRE_VERSION ${X_OGRE_VERSION})
+  set(OGRE_INCLUDE_DIRS ${X_INCLUDE_DIRS})
+  message(STATUS "OGRE_INCLUDE_DIRS=${OGRE_INCLUDE_DIRS}")
+
+  # Find absolute path of OGRE libraries.
+  # This is stored in the cache to save time on cmake re-run.
+  # Using absolute paths is necessary if pkg-config finds Ogre in a different
+  # location than the default.  This can happen when Ogre is built from source,
+  # or when 2 versions of Ogre are installed.  Using absolute paths ensures that
+  # components that link against Ogre (rviz and any packages depending on rviz)
+  # all find the same Ogre shared library.
+  if(NOT DEFINED OGRE_LIBRARIES)
+    set(_OGRE_LIBRARIES)
+    foreach(_lib ${X_LIBRARIES})
+      set(_lib_tag "OGRE_RVIZ_${_lib}")
+
+      find_library(${_lib_tag}
+              NAMES ${_lib}
+              HINTS ${X_LIBRARY_DIRS}
+              PATHS ${X_LIBRARY_DIRS}
+      )
+
+      list(APPEND _OGRE_LIBRARIES ${${_lib_tag}})
+    endforeach(_lib)
+
+    set(OGRE_LIBRARIES ${_OGRE_LIBRARIES} CACHE STRING "Absolute paths to OGRE libs")
+  endif(NOT DEFINED OGRE_LIBRARIES)
+  message(STATUS "OGRE_LIBRARIES=${OGRE_LIBRARIES}")
+
+  ## Fetch OGRE_PLUGIN_DIR variable from pkg-config
+  if(NOT DEFINED OGRE_PLUGIN_DIR)
+    execute_process(COMMAND
+      ${PKG_CONFIG_EXECUTABLE} --variable=plugindir OGRE
+      OUTPUT_VARIABLE OGRE_PLUGIN_DIR
+      OUTPUT_STRIP_TRAILING_WHITESPACE
+      )
+  endif(NOT DEFINED OGRE_PLUGIN_DIR)
+  message(STATUS "OGRE_PLUGIN_DIR=${OGRE_PLUGIN_DIR}")
+endif()
+
+# TODO: adapt version after upgrade to newer OGRE release
 # Disable deprecation warnings for OGRE >= 1.10
-if(NOT X_OGRE_VERSION VERSION_LESS "1.10.0" AND NOT MSVC)
+if(NOT OGRE_VERSION VERSION_LESS "1.10.0" AND NOT MSVC)
   add_compile_options(-Wno-deprecated-declarations)
 endif()
-
-# find absolute path of ogre libraries.
-# This is stored in the cache to save time on cmake re-run.
-# Using absolute paths is necessary if pkg-config finds Ogre in a different
-# location than the default.  This can happen when Ogre is built from source,
-# or when 2 versions of Ogre are installed.  Using absolute paths ensures that
-# components that link against Ogre (rviz and any packages depending on rviz)
-# all find the same Ogre shared library.
-if(NOT DEFINED OGRE_LIBRARIES)
-  set(_OGRE_LIBRARIES)
-  foreach(_lib ${X_LIBRARIES})
-    set(_lib_tag "OGRE_RVIZ_${_lib}")
-
-    find_library(${_lib_tag}
-            NAMES ${_lib}
-            HINTS ${X_LIBRARY_DIRS}
-            PATHS ${X_LIBRARY_DIRS}
-    )
-
-    list(APPEND _OGRE_LIBRARIES ${${_lib_tag}})
-  endforeach(_lib)
-
-  set(OGRE_LIBRARIES ${_OGRE_LIBRARIES} CACHE STRING "Absolute paths to OGRE libs")
-endif(NOT DEFINED OGRE_LIBRARIES)
-message(STATUS "OGRE_LIBRARIES=${OGRE_LIBRARIES}")
-
-# Define OGRE_INCLUDE_DIRS as find_package would do
-set(OGRE_INCLUDE_DIRS ${X_INCLUDE_DIRS})
-message(STATUS "OGRE_INCLUDE_DIRS=${OGRE_INCLUDE_DIRS}")
-
-## Find OGRE Plugin path (not necessarily platform-independent, I guess)
-if(NOT DEFINED OGRE_PLUGIN_PATH)
-  execute_process(COMMAND
-    ${PKG_CONFIG_EXECUTABLE} --variable=plugindir OGRE
-    OUTPUT_VARIABLE OGRE_PLUGIN_PATH
-    OUTPUT_STRIP_TRAILING_WHITESPACE
-    )
-endif(NOT DEFINED OGRE_PLUGIN_PATH)
-message(STATUS "OGRE_PLUGIN_PATH=${OGRE_PLUGIN_PATH}")
 
 if(APPLE)
   FIND_LIBRARY(Cocoa_LIBRARIES Cocoa)
@@ -204,21 +212,18 @@
     visualization_msgs
 )
 
-if(CMAKE_VERSION VERSION_GREATER_EQUAL "3.14.0")
-    set(SYSTEM "SYSTEM")
-endif()
-
-include_directories(${SYSTEM}
+#catkin_lint: ignore_once external_directory
+include_directories(src ${EXPORT_HEADER_DIR})
+include_directories(SYSTEM
   ${EIGEN3_INCLUDE_DIRS}
   ${OGRE_INCLUDE_DIRS}
   ${OPENGL_INCLUDE_DIR}
   ${PYTHON_INCLUDE_PATH}
   ${TinyXML2_INCLUDE_DIRS}
   ${urdfdom_headers_INCLUDE_DIRS}
-)
-#catkin_lint: ignore_once external_directory
-include_directories(src ${EXPORT_HEADER_DIR})
-include_directories(${SYSTEM} ${catkin_INCLUDE_DIRS})
+  ${ASSIMP_INCLUDE_DIRS}
+  ${catkin_INCLUDE_DIRS}
+)
 
 #### If gtk ends up being the best way to get the correct window
 #### position under X11, this is how to compile it in.
@@ -229,8 +234,15 @@
 
 add_subdirectory(src)
 
+if(OGRE_VERSION VERSION_LESS "1.10")
+  set(EXCLUDE_PATTERN "ogre1.10.*")
+else()
+  set(EXCLUDE_PATTERN "ogre1.9.*")
+endif()
+
 install(DIRECTORY ogre_media
   DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
+  PATTERN "${EXCLUDE_PATTERN}" EXCLUDE
 )
 install(DIRECTORY icons
   DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}

=== src/image_view/CMakeLists.txt ===
add_executable(rviz_image_view
  image_view.cpp
  main.cpp
)
if(NOT WIN32)
  set_target_properties(rviz_image_view PROPERTIES COMPILE_FLAGS "-std=c++11")
endif()

target_link_libraries(rviz_image_view
  ${OGRE_LIBRARIES}
  ${rviz_ADDITIONAL_LIBRARIES}
  ${PROJECT_NAME}
)

set_target_properties(rviz_image_view
                      PROPERTIES OUTPUT_NAME image_view
                      PREFIX "")

=== src/test/CMakeLists.txt ===
# rviz's automated tests
find_package(rostest REQUIRED)

# This is a test utility which publishes images of different types.
add_executable(send_images EXCLUDE_FROM_ALL send_images.cpp)
if(NOT WIN32)
  set_target_properties(send_images PROPERTIES COMPILE_FLAGS "-std=c++11")
endif()
target_link_libraries(send_images ${catkin_LIBRARIES})
add_dependencies(tests send_images)

# This is a test utility which can publish different kinds of markers.
add_executable(marker_test EXCLUDE_FROM_ALL marker_test.cpp)
if(NOT WIN32)
  set_target_properties(marker_test PROPERTIES COMPILE_FLAGS "-std=c++11")
endif()
target_link_libraries(marker_test ${catkin_LIBRARIES})
add_dependencies(tests marker_test)

# This is a test utility which can publish different kinds of mesh markers.
add_executable(mesh_marker_test EXCLUDE_FROM_ALL mesh_marker_test.cpp)
if(NOT WIN32)
  set_target_properties(mesh_marker_test PROPERTIES COMPILE_FLAGS "-std=c++11")
endif()
target_link_libraries(mesh_marker_test ${catkin_LIBRARIES})
add_dependencies(tests mesh_marker_test)

# This is a GTest which tests the different types of primitive display properties.
catkin_add_gtest(property_test
  property_test.cpp
  mock_property_change_receiver.cpp
  ${MOC_MOCK_PROPERTY_CHANGE_RECEIVER}
)
target_link_libraries(property_test rviz ${catkin_LIBRARIES} ${QT_LIBRARIES})

# TODO(wjwwood): Fix this test, it used to use a set of Mock classes, but
#                has since undergone a lot of changes and it no longer works.
# This is a GTest which tests the display system.
# add_rostest_gtest(display_test display_test.test
#   display_test.cpp
#   mock_context.cpp
#   mock_display.cpp
#   mock_display_factory.cpp
#   mock_property_change_receiver.cpp
# )
# target_link_libraries(display_test rviz ${catkin_LIBRARIES} ${QT_LIBRARIES})

# This is a GTest which tests the uniform_string_stream.
catkin_add_gtest(uniform_string_stream_test
  uniform_string_stream_test.cpp
  ../rviz/uniform_string_stream.cpp
)

# This is an example node which serves an rviz logo as an interactive marker.
add_executable(rviz_logo_marker EXCLUDE_FROM_ALL rviz_logo_marker.cpp)
if(NOT WIN32)
  set_target_properties(rviz_logo_marker PROPERTIES COMPILE_FLAGS "-std=c++11")
endif()
target_link_libraries(rviz_logo_marker ${catkin_LIBRARIES})
add_dependencies(tests rviz_logo_marker)

# This is an example node which publishes different kinds of point clouds.
add_executable(cloud_test EXCLUDE_FROM_ALL cloud_test.cpp)
if(NOT WIN32)
  set_target_properties(cloud_test PROPERTIES COMPILE_FLAGS "-std=c++11")
endif()
target_link_libraries(cloud_test ${catkin_LIBRARIES})
add_dependencies(tests cloud_test)

# This is an example node which serves an interactive marker.
add_executable(interactive_marker_test interactive_marker_test.cpp)
if(NOT WIN32)
  set_target_properties(interactive_marker_test PROPERTIES COMPILE_FLAGS "-std=c++11")
endif()
target_link_libraries(interactive_marker_test ${catkin_LIBRARIES})
add_dependencies(tests interactive_marker_test)

# This is another example node that publishes images.
add_executable(image_test EXCLUDE_FROM_ALL image_test.cpp)
if(NOT WIN32)
  set_target_properties(image_test PROPERTIES COMPILE_FLAGS "-std=c++11")
endif()
target_link_libraries(image_test ${catkin_LIBRARIES})
add_dependencies(tests image_test)

# This is a node that sends lots of point clouds.
add_executable(send_lots_of_points EXCLUDE_FROM_ALL send_lots_of_points_node.cpp)
if(NOT WIN32)
  set_target_properties(send_lots_of_points PROPERTIES COMPILE_FLAGS "-std=c++11")
endif()
target_link_libraries(send_lots_of_points ${catkin_LIBRARIES})
add_dependencies(tests send_lots_of_points)

# Yet another example which sends point clouds.
add_executable(send_point_cloud_2 EXCLUDE_FROM_ALL send_point_cloud_2.cpp)
if(NOT WIN32)
  set_target_properties(send_point_cloud_2 PROPERTIES COMPILE_FLAGS "-std=c++11")
endif()
target_link_libraries(send_point_cloud_2 ${catkin_LIBRARIES})
add_dependencies(tests send_point_cloud_2)

# This is a node which sends grid cells.
add_executable(send_grid_cells EXCLUDE_FROM_ALL send_grid_cells_node.cpp)
if(NOT WIN32)
  set_target_properties(send_grid_cells PROPERTIES COMPILE_FLAGS "-std=c++11")
endif()
target_link_libraries(send_grid_cells ${catkin_LIBRARIES})
add_dependencies(tests send_grid_cells)

# This is a test program that uses the rviz panel interface.
add_executable(render_panel_test render_panel_test.cpp)
if(NOT WIN32)
  set_target_properties(render_panel_test PROPERTIES COMPILE_FLAGS "-std=c++11")
endif()
target_link_libraries(render_panel_test rviz ${catkin_LIBRARIES} ${QT_LIBRARIES})
add_dependencies(tests render_panel_test)

# This is an executable which uses the rviz new display diaglog interface.
add_executable(new_display_dialog_test new_display_dialog_test.cpp)
if(NOT WIN32)
  set_target_properties(new_display_dialog_test PROPERTIES COMPILE_FLAGS "-std=c++11")
endif()
target_link_libraries(new_display_dialog_test rviz ${catkin_LIBRARIES} ${QT_LIBRARIES})
add_dependencies(tests new_display_dialog_test)

# This is an executable which uses the rviz color editor test.
add_executable(color_editor_test color_editor_test.cpp)
if(NOT WIN32)
  set_target_properties(color_editor_test PROPERTIES COMPILE_FLAGS "-std=c++11")
endif()
target_link_libraries(color_editor_test rviz ${catkin_LIBRARIES} ${QT_LIBRARIES})
add_dependencies(tests color_editor_test)

# This is a modified version of the property test.
catkin_add_gtest(property_with_ros_spinner_test
  property_test.cpp
  ros_spinner.cpp
  mock_property_change_receiver.cpp
  ${MOC_MOCK_PROPERTY_CHANGE_RECEIVER}
)
target_link_libraries(property_with_ros_spinner_test rviz ${catkin_LIBRARIES} ${QT_LIBRARIES})
add_dependencies(tests property_with_ros_spinner_test)

# This is an executable that uses the line_edit_with_button property interface.
add_executable(line_edit_with_button_test line_edit_with_button_test.cpp)
if(NOT WIN32)
  set_target_properties(line_edit_with_button_test PROPERTIES COMPILE_FLAGS "-std=c++11")
endif()
target_link_libraries(line_edit_with_button_test rviz ${catkin_LIBRARIES} ${QT_LIBRARIES})
add_dependencies(tests line_edit_with_button_test)

# This is an executable which tests the connect/disconnect behavior of signals and slots in Qt.
add_executable(connect_test connect_test.cpp)
if(NOT WIN32)
  set_target_properties(connect_test PROPERTIES COMPILE_FLAGS "-std=c++11")
endif()
target_link_libraries(connect_test ${QT_LIBRARIES})
add_dependencies(tests connect_test)

# This is a GTest which tests the display configuration.
catkin_add_gtest(config_test config_test.cpp ../rviz/uniform_string_stream.cpp ../rviz/config.cpp)
target_link_libraries(config_test ${QT_LIBRARIES})

# This is an acceptance test executable which renders points.
add_executable(render_points_test
  render_points_test.cpp
  ../rviz/ogre_helpers/orbit_camera.cpp
)
if(NOT WIN32)
  set_target_properties(render_points_test PROPERTIES COMPILE_FLAGS "-std=c++11")
endif()
target_link_libraries(render_points_test rviz ${catkin_LIBRARIES} ${QT_LIBRARIES})
add_dependencies(tests render_points_test)

# This is an example application which creates two ogre render windows.
add_executable(two_render_widgets two_render_widgets.cpp)
if(NOT WIN32)
  set_target_properties(two_render_widgets PROPERTIES COMPILE_FLAGS "-std=c++11")
endif()
target_link_libraries(two_render_widgets rviz ${catkin_LIBRARIES} ${QT_LIBRARIES})
add_dependencies(tests two_render_widgets)

# This is a GTest which tests the STL loader of assimp
#catkin_lint: ignore_once env_var
if (DEFINED ENV{DISPLAY} AND NOT $ENV{DISPLAY} STREQUAL "")
  catkin_add_gtest(stl_loader_test stl_loader_test.cpp)
  target_link_libraries(stl_loader_test ${catkin_LIBRARIES} ${PROJECT_NAME})
else()
  message("No display, will not configure tests for rviz/stl_loader")
endif()

=== debian/changelog ===
ros-rviz (1.14.4+dfsg-3) unstable; urgency=medium

  * simplify packaging

 -- Jochen Sprickerhof <jspricke@debian.org>  Sat, 19 Dec 2020 18:16:07 +0100

ros-rviz (1.14.4+dfsg-2) unstable; urgency=medium

  * Add patch for Boost 1.74
  * bump policy version (no changes)

 -- Jochen Sprickerhof <jspricke@debian.org>  Tue, 15 Dec 2020 13:59:32 +0100

ros-rviz (1.14.4+dfsg-1) unstable; urgency=medium

  * New upstream version 1.14.4+dfsg

 -- Jochen Sprickerhof <jspricke@debian.org>  Wed, 18 Nov 2020 11:41:29 +0100

ros-rviz (1.14.3+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 1.14.3+dfsg
  * Link against OGRE 1.12

 -- Timo Röhling <timo@gaussglocke.de>  Fri, 06 Nov 2020 17:58:42 +0100

=== debian/control ===
Source: ros-rviz
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Jochen Sprickerhof <jspricke@debian.org>,
           Leopold Palomo-Avellaneda <leo@alaxarxa.net>
Build-Depends: debhelper-compat (= 13), catkin, libboost-filesystem-dev, libboost-program-options-dev, libboost-system-dev, libboost-thread-dev, libassimp-dev, libgl1-mesa-dev | libgl-dev, libqt5opengl5-dev, libimage-transport-dev, libinteractive-markers-dev (>= 1.12.0) , liblaser-geometry-dev, libmap-msgs-dev, libmessage-filters-dev, libnav-msgs-dev, pluginlib-dev, python3-python-qt-binding, libresource-retriever-dev, librosbag-dev, librosconsole-dev, libroscpp-dev, libroslib-dev, python3-rospy, libsensor-msgs-dev, libstd-msgs-dev, libstd-srvs-dev, libtf-dev, liburdf-dev, libvisualization-msgs-dev, libeigen3-dev, libogre-1.12-dev, librostest-dev, libyaml-cpp-dev, liburdfdom-dev, python3-all-dev, dh-sequence-python3, python3-sip-dev, libx11-dev, chrpath, libstd-msgs-dev, ros-std-msgs,
Standards-Version: 4.5.1
Section: libs
Rules-Requires-Root: no
Homepage: https://wiki.ros.org/rviz
Vcs-Git: https://salsa.debian.org/science-team/ros-rviz.git
Vcs-Browser: https://salsa.debian.org/science-team/ros-rviz

Package: librviz-dev
Section: libdevel
Architecture: any
Depends: librviz5d (= ${binary:Version}), ${misc:Depends}, libimage-transport-dev, libinteractive-markers-dev (>= 1.12.0) , liblaser-geometry-dev, libmap-msgs-dev, libmessage-filters-dev, libnav-msgs-dev, pluginlib-dev, python3-python-qt-binding, libresource-retriever-dev, librosbag-dev, librosconsole-dev, libroscpp-dev, libroslib-dev, python3-rospy, libsensor-msgs-dev, libstd-msgs-dev, libstd-srvs-dev, libtf-dev, liburdf-dev, libvisualization-msgs-dev, libogre-1.12-dev
Description: Development files for the Robot OS 3D visualization tool
 This package is part of Robot OS (ROS) RViz package. RViz is a tool to
 visualize ROS messages and the state of the robot.
 .
 This package contains the development files for the rviz library.

Package: librviz5d
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Library for the Robot OS 3D visualization tool
 This package is part of Robot OS (ROS) RViz package. RViz is a tool to
 visualize ROS messages and the state of the robot.
 .
 This package contains the rviz library.

Package: rviz
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, fonts-liberation, libqt5svg5
Description: 3D visualization tool for Robot OS
 This package is part of Robot OS (ROS) RViz package. RViz is a tool to
 visualize ROS messages and the state of the robot.
 .
 This package contains the rviz program.

Package: python3-rviz
Section: python
Architecture: any
Depends: ${python3:Depends}, ${sip3:Depends}, ${shlibs:Depends}, ${misc:Depends}, python3-python-qt-binding
Description: Python 3 bindings for the 3D visualization tool for Robot OS
 This package is part of Robot OS (ROS) RViz package. RViz is a tool to
 visualize ROS messages and the state of the robot.
 .
 This package contains the Python 3 interface to the rviz library.

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_CONFIGURE_ARGS=-DPYBUILD_PYTHON_VERSION={version} -DCATKIN_ENABLE_TESTING=OFF
export PYBUILD_SYSTEM=cmake

%:
	dh $@ --with=sip3 --buildsystem=pybuild

override_dh_auto_install:
	dh_auto_install
	chrpath -d debian/tmp/usr/lib/python3*/*/rviz/*.so

## ros-rviz 1.14.14%2Bdfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -26,14 +26,19 @@
 find_package(urdfdom_headers REQUIRED)
 
 set(CMAKE_POLICY_DEFAULT_CMP0012 NEW)  # required due to a bug in assimp 5.0
-find_package(ASSIMP REQUIRED)
+find_package(assimp REQUIRED)
 if(NOT DEFINED ASSIMP_LIBRARIES AND TARGET assimp::assimp)
   # ASSIMP >= 5.0 no longer defines ASSIMP_LIBRARIES
   set(ASSIMP_LIBRARIES assimp::assimp)
 endif()
 
 find_package(OGRE QUIET COMPONENTS Overlay)
-if(NOT OGRE_FOUND)
+if(OGRE_FOUND)
+  if(${OGRE_VERSION} VERSION_LESS 1.11)
+    set(OGRE_INCLUDE_DIRS ${OGRE_INCLUDE_DIRS} ${OGRE_Overlay_INCLUDE_DIRS})
+    set(OGRE_LIBRARIES ${OGRE_LIBRARIES} ${OGRE_Overlay_LIBRARIES})
+  endif()
+else()
   # OGRE doesn't come with correctly installed cmake files on Linux. Use pkg-config instead.
   # We need both, OGRE and OGRE-Overlay. Look for both simulatenously and use prefix X_
   find_package(PkgConfig REQUIRED)
@@ -123,7 +128,6 @@
   pluginlib
   python_qt_binding
   resource_retriever
-  rosbag
   rosconsole
   roscpp
   roslib
